<?php
/********
 **		AdminCP Dropdown Menus  for MyBB 1.4/1.6
 **		By ZiNgA BuRgA
 **
 ********/


$plugins->add_hook('admin_load', 'acpdropmenus_inject');

function acpdropmenus_info()
{
	return array(
		'name'			=> 'AdminCP Dropdown Menus',
		'description'	=> 'Makes the main menus in the AdminCP dropdown menus for faster access.',
		'website'		=> 'http://mybbhacks.zingaburga.com/',
		'author'		=> 'ZiNgA BuRgA',
		'authorsite'	=> 'http://zingaburga.com/',
		'version'		=> '1.2',
		'compatibility'	=> '14*,15*,16*,17*,18*',
		'guid'			=> ''
	);
}

function acpdropmenus_inject()
{
	class acpdropmenus_page extends Page
	{
		function _build_menu()
		{
			if(!is_array($this->_menu))
			{
				return false;
			}
			$build_menu = "<div id=\"menu\">\n<ul>\n";
			ksort($this->_menu);
			$menu_popups = array();
			foreach($this->_menu as $items)
			{
				foreach($items as $menu_item)
				{
					$menu_item['link'] = htmlspecialchars($menu_item['link']);
					
					$popup = new PopupMenu('acpmenu_'.$menu_item['id']);
					end($menu_item['submenu']);
					$endkey = key($menu_item['submenu']);
					$run_hack = ($menu_item['id'] == 'tools' || $menu_item['id'] == 'home');
					foreach($menu_item['submenu'] as $key => &$submenu_item) {
						$suffix = '';
						if($key == $endkey && $run_hack) {
							$suffix = '</a></div><div><hr style="margin-top: -1px; margin-bottom: -1px;" /><a id="acpdropmenus_dummy_'.md5(mt_rand()).'">';
						}
						$popup->add_item($submenu_item['title'].$suffix, $submenu_item['link']);
					}
					// hack for Home/Tools links
					if($run_hack && function_exists($menu_item['id'].'_action_handler')) {
						/*
						// save some stuff down
						$save_props = array(
							'active_module' => $this->active_module,
							'active_action' => $this->active_action,
						);
						global $acpdropmenus_sidebar_null, $acpdropmenus_submenus, $plugins;
						$old_hooks = $plugins->hooks['admin_tools_action_handler'];
						unset($plugins->hooks['admin_tools_action_handler']);
						
						// run destructive function
						$acpdropmenus_sidebar_null = true;
						$acpdropmenus_submenus = array();
						tools_action_handler('');
						
						// restore stuff
						$acpdropmenus_sidebar_null = false;
						foreach($save_props as $k => &$v)
							$this->$k = $v;
						$plugins->hooks['admin_tools_action_handler'] = $old_hooks;
						
						// add popup items
						foreach($acpdropmenus_submenus as $title => &$sub_menu)
							foreach($sub_menu as &$submenu_item)
								$popup->add_item($submenu_item['title'], $submenu_item['link']);
						*/
						
						
						
						// we need to save stuff that'll be modified (so we can revert)
						$save_props = array(
							'active_module' => $this->active_module,
							'active_action' => $this->active_action,
							'sidebar' => $this->sidebar,
						);
						// remove some plugin hooks and add our own
						global $plugins;
						$rmhooks = 'admin_'.$menu_item['id'].'_action_handler';
						$old_hooks = $plugins->hooks[$rmhooks];
						unset($plugins->hooks[$rmhooks]);
						if($menu_item['id'] == 'tools')
							$plugins->add_hook('admin_tools_menu_logs', 'acpdropmenus_tools_hack', 99999);
						elseif($menu_item['id'] == 'home')
							$plugins->add_hook('admin_home_menu_quick_access', 'acpdropmenus_tools_hack', 99999);
						
						// run the destructive function
						$func = $menu_item['id'].'_action_handler';
						$func('');
						
						// revert stuff
						foreach($save_props as $k => &$v)
							$this->$k = $v;
						$plugins->hooks[$rmhooks] = $old_hooks;
						
						// add popup items
						foreach($GLOBALS['acpdropmenus_tools'] as &$submenu_item)
							$popup->add_item($submenu_item['title'], $submenu_item['link']);
					}
					$menu_popups[] = $popup->fetch();
					unset($popup);
					
					if($menu_item['id'] == $this->active_module)
					{
						$sub_menu = $menu_item['submenu'];
						$sub_menu_title = $menu_item['title'];
						$build_menu .= "<li><a href=\"{$menu_item['link']}\" class=\"active\" id=\"acpmenu_{$menu_item['id']}\">{$menu_item['title']}</a></li>\n";
					}
					else
					{
						$build_menu .= "<li><a href=\"{$menu_item['link']}\" id=\"acpmenu_{$menu_item['id']}\">{$menu_item['title']}</a></li>\n";
					}
				}
			}
			$build_menu .= "</ul>\n</div>";
			foreach($menu_popups as $mp)
				$build_menu .= $mp;

			if($sub_menu)
			{
				$this->_build_submenu($sub_menu_title, $sub_menu);
			}
			return $build_menu;
		}
		
		
		function acpdropmenus_page(&$oldpage)
		{
			$vars = get_object_vars($oldpage);
			foreach($vars as $var => $val)
			{
				$this->$var = $val;
			}
		}
	}
	
	global $page;
	$page = new acpdropmenus_page($page);
	
}

/*
// we hope a theme isn't trying to override this
require_once MYBB_ROOT.$GLOBALS['config']['admin_dir'].'/inc/class_page.php';
class SidebarItem extends DefaultSidebarItem {
	function add_menu_items($items, $active) {
		$GLOBALS['acpdropmenus_submenus'][$this->_title_public] = $items;
		return parent::add_menu_items($items, $active);
	}
	function get_markup() {
		if($GLOBALS['acpdropmenus_sidebar_null']) return '';
		return parent::get_markup();
	}
	function __construct($title='') {
		$this->_title_public = $title;
		return parent::__construct($title);
	}
	function SidebarItem($title='') {
		return $this->__construct($title);
	}
}
*/

function acpdropmenus_tools_hack(&$sub_menu) {
	$GLOBALS['acpdropmenus_tools'] = $sub_menu;
}

?>